~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/tools/testing/selftests/net/msg_zerocopy.sh

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

  1 #!/bin/bash
  2 #
  3 # Send data between two processes across namespaces
  4 # Run twice: once without and once with zerocopy
  5 
  6 set -e
  7 
  8 readonly DEV="veth0"
  9 readonly DEV_MTU=65535
 10 readonly BIN="./msg_zerocopy"
 11 
 12 readonly RAND="$(mktemp -u XXXXXX)"
 13 readonly NSPREFIX="ns-${RAND}"
 14 readonly NS1="${NSPREFIX}1"
 15 readonly NS2="${NSPREFIX}2"
 16 
 17 readonly SADDR4='192.168.1.1'
 18 readonly DADDR4='192.168.1.2'
 19 readonly SADDR6='fd::1'
 20 readonly DADDR6='fd::2'
 21 
 22 readonly path_sysctl_mem="net.core.optmem_max"
 23 
 24 # No arguments: automated test
 25 if [[ "$#" -eq "0" ]]; then
 26         $0 4 tcp -t 1
 27         $0 6 tcp -t 1
 28         $0 4 udp -t 1
 29         $0 6 udp -t 1
 30         echo "OK. All tests passed"
 31         exit 0
 32 fi
 33 
 34 # Argument parsing
 35 if [[ "$#" -lt "2" ]]; then
 36         echo "Usage: $0 [4|6] [tcp|udp|raw|raw_hdrincl|packet|packet_dgram] <args>"
 37         exit 1
 38 fi
 39 
 40 readonly IP="$1"
 41 shift
 42 readonly TXMODE="$1"
 43 shift
 44 readonly EXTRA_ARGS="$@"
 45 
 46 # Argument parsing: configure addresses
 47 if [[ "${IP}" == "4" ]]; then
 48         readonly SADDR="${SADDR4}"
 49         readonly DADDR="${DADDR4}"
 50 elif [[ "${IP}" == "6" ]]; then
 51         readonly SADDR="${SADDR6}"
 52         readonly DADDR="${DADDR6}"
 53 else
 54         echo "Invalid IP version ${IP}"
 55         exit 1
 56 fi
 57 
 58 # Argument parsing: select receive mode
 59 #
 60 # This differs from send mode for
 61 # - packet:     use raw recv, because packet receives skb clones
 62 # - raw_hdrinc: use raw recv, because hdrincl is a tx-only option
 63 case "${TXMODE}" in
 64 'packet' | 'packet_dgram' | 'raw_hdrincl')
 65         RXMODE='raw'
 66         ;;
 67 *)
 68         RXMODE="${TXMODE}"
 69         ;;
 70 esac
 71 
 72 # Start of state changes: install cleanup handler
 73 
 74 cleanup() {
 75         ip netns del "${NS2}"
 76         ip netns del "${NS1}"
 77 }
 78 
 79 trap cleanup EXIT
 80 
 81 # Create virtual ethernet pair between network namespaces
 82 ip netns add "${NS1}"
 83 ip netns add "${NS2}"
 84 
 85 # Configure system settings
 86 ip netns exec "${NS1}" sysctl -w -q "${path_sysctl_mem}=1000000"
 87 ip netns exec "${NS2}" sysctl -w -q "${path_sysctl_mem}=1000000"
 88 
 89 ip link add "${DEV}" mtu "${DEV_MTU}" netns "${NS1}" type veth \
 90   peer name "${DEV}" mtu "${DEV_MTU}" netns "${NS2}"
 91 
 92 # Bring the devices up
 93 ip -netns "${NS1}" link set "${DEV}" up
 94 ip -netns "${NS2}" link set "${DEV}" up
 95 
 96 # Set fixed MAC addresses on the devices
 97 ip -netns "${NS1}" link set dev "${DEV}" address 02:02:02:02:02:02
 98 ip -netns "${NS2}" link set dev "${DEV}" address 06:06:06:06:06:06
 99 
100 # Add fixed IP addresses to the devices
101 ip -netns "${NS1}" addr add 192.168.1.1/24 dev "${DEV}"
102 ip -netns "${NS2}" addr add 192.168.1.2/24 dev "${DEV}"
103 ip -netns "${NS1}" addr add       fd::1/64 dev "${DEV}" nodad
104 ip -netns "${NS2}" addr add       fd::2/64 dev "${DEV}" nodad
105 
106 # Optionally disable sg or csum offload to test edge cases
107 # ip netns exec "${NS1}" ethtool -K "${DEV}" sg off
108 
109 do_test() {
110         local readonly ARGS="$1"
111 
112         echo "ipv${IP} ${TXMODE} ${ARGS}"
113         ip netns exec "${NS2}" "${BIN}" "-${IP}" -i "${DEV}" -t 2 -C 2 -S "${SADDR}" -D "${DADDR}" ${ARGS} -r "${RXMODE}" &
114         sleep 0.2
115         ip netns exec "${NS1}" "${BIN}" "-${IP}" -i "${DEV}" -t 1 -C 3 -S "${SADDR}" -D "${DADDR}" ${ARGS} "${TXMODE}"
116         wait
117 }
118 
119 do_test "${EXTRA_ARGS}"
120 do_test "-z ${EXTRA_ARGS}"
121 echo ok

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php